#!/bin/bash

set -e

BASE_DIR=storage/app

# If FIDO_DIR not set, source the env file
[ -z "${FIDO_DIR}" -a -r .env ] && . .env

FIDO_DIR=${FIDO_DIR:-fido}

if [ ! -d "${BASE_DIR}/${FIDO_DIR}" ]; then
	if ! mkdir ${BASE_DIR}/${FIDO_DIR}; then
		echo "! ERROR creating FIDO_DIR [${BASE_DIR}/${FIDO_DIR}]"
		exit 1
	fi
fi

echo "* Ready to start server"
echo "  - INBOUND [${BASE_DIR}/${FIDO_DIR}]"

exec su www-data -s /bin/sh -c "./artisan server:start"
